<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Inspection StructType
 * @subpackage Structs
 */
class Inspection extends AbstractDocumentHolder
{
    /**
     * The areas
     * Meta information extracted from the WSDL
     * - arrayType: xsd:anyType[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var mixed[]
     */
    public $areas;
    /**
     * The building
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\Building
     */
    public $building;
    /**
     * The comment
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $comment;
    /**
     * The dateInspected
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $dateInspected;
    /**
     * The dateScheduled
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $dateScheduled;
    /**
     * The inspector
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\User
     */
    public $inspector;
    /**
     * The lease
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\Lease
     */
    public $lease;
    /**
     * The number
     * @var int
     */
    public $number;
    /**
     * The portfolio
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\Portfolio
     */
    public $portfolio;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $status;
    /**
     * The templateName
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $templateName;
    /**
     * The timeInspected
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $timeInspected;
    /**
     * The timeScheduled
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $timeScheduled;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $type;
    /**
     * The unit
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\Unit
     */
    public $unit;
    /**
     * Constructor method for Inspection
     * @uses Inspection::setAreas()
     * @uses Inspection::setBuilding()
     * @uses Inspection::setComment()
     * @uses Inspection::setDateInspected()
     * @uses Inspection::setDateScheduled()
     * @uses Inspection::setInspector()
     * @uses Inspection::setLease()
     * @uses Inspection::setNumber()
     * @uses Inspection::setPortfolio()
     * @uses Inspection::setStatus()
     * @uses Inspection::setTemplateName()
     * @uses Inspection::setTimeInspected()
     * @uses Inspection::setTimeScheduled()
     * @uses Inspection::setType()
     * @uses Inspection::setUnit()
     * @param mixed[] $areas
     * @param \StructType\Building $building
     * @param string $comment
     * @param string $dateInspected
     * @param string $dateScheduled
     * @param \StructType\User $inspector
     * @param \StructType\Lease $lease
     * @param int $number
     * @param \StructType\Portfolio $portfolio
     * @param string $status
     * @param string $templateName
     * @param string $timeInspected
     * @param string $timeScheduled
     * @param string $type
     * @param \StructType\Unit $unit
     */
    public function __construct(array $areas = array(), \StructType\Building $building = null, $comment = null, $dateInspected = null, $dateScheduled = null, \StructType\User $inspector = null, \StructType\Lease $lease = null, $number = null, \StructType\Portfolio $portfolio = null, $status = null, $templateName = null, $timeInspected = null, $timeScheduled = null, $type = null, \StructType\Unit $unit = null)
    {
        $this
            ->setAreas($areas)
            ->setBuilding($building)
            ->setComment($comment)
            ->setDateInspected($dateInspected)
            ->setDateScheduled($dateScheduled)
            ->setInspector($inspector)
            ->setLease($lease)
            ->setNumber($number)
            ->setPortfolio($portfolio)
            ->setStatus($status)
            ->setTemplateName($templateName)
            ->setTimeInspected($timeInspected)
            ->setTimeScheduled($timeScheduled)
            ->setType($type)
            ->setUnit($unit);
    }
    /**
     * Get areas value
     * @return mixed[]|null
     */
    public function getAreas()
    {
        return $this->areas;
    }
    /**
     * This method is responsible for validating the values passed to the setAreas method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAreas method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAreasForArrayConstraintsFromSetAreas(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $inspectionAreasItem) {
            // validation for constraint: itemType
            if (false) {
                $invalidValues[] = is_object($inspectionAreasItem) ? get_class($inspectionAreasItem) : sprintf('%s(%s)', gettype($inspectionAreasItem), var_export($inspectionAreasItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The areas property can only contain items of type anyType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set areas value
     * @throws \InvalidArgumentException
     * @param mixed[] $areas
     * @return \StructType\Inspection
     */
    public function setAreas(array $areas = array())
    {
        // validation for constraint: array
        if ('' !== ($areasArrayErrorMessage = self::validateAreasForArrayConstraintsFromSetAreas($areas))) {
            throw new \InvalidArgumentException($areasArrayErrorMessage, __LINE__);
        }
        $this->areas = $areas;
        return $this;
    }
    /**
     * Add item to areas value
     * @throws \InvalidArgumentException
     * @param mixed $item
     * @return \StructType\Inspection
     */
    public function addToAreas($item)
    {
        // validation for constraint: itemType
        if (false) {
            throw new \InvalidArgumentException(sprintf('The areas property can only contain items of type anyType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->areas[] = $item;
        return $this;
    }
    /**
     * Get building value
     * @return \StructType\Building|null
     */
    public function getBuilding()
    {
        return $this->building;
    }
    /**
     * Set building value
     * @param \StructType\Building $building
     * @return \StructType\Inspection
     */
    public function setBuilding(\StructType\Building $building = null)
    {
        $this->building = $building;
        return $this;
    }
    /**
     * Get comment value
     * @return string|null
     */
    public function getComment()
    {
        return $this->comment;
    }
    /**
     * Set comment value
     * @param string $comment
     * @return \StructType\Inspection
     */
    public function setComment($comment = null)
    {
        // validation for constraint: string
        if (!is_null($comment) && !is_string($comment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comment, true), gettype($comment)), __LINE__);
        }
        $this->comment = $comment;
        return $this;
    }
    /**
     * Get dateInspected value
     * @return string|null
     */
    public function getDateInspected()
    {
        return $this->dateInspected;
    }
    /**
     * Set dateInspected value
     * @param string $dateInspected
     * @return \StructType\Inspection
     */
    public function setDateInspected($dateInspected = null)
    {
        // validation for constraint: string
        if (!is_null($dateInspected) && !is_string($dateInspected)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateInspected, true), gettype($dateInspected)), __LINE__);
        }
        $this->dateInspected = $dateInspected;
        return $this;
    }
    /**
     * Get dateScheduled value
     * @return string|null
     */
    public function getDateScheduled()
    {
        return $this->dateScheduled;
    }
    /**
     * Set dateScheduled value
     * @param string $dateScheduled
     * @return \StructType\Inspection
     */
    public function setDateScheduled($dateScheduled = null)
    {
        // validation for constraint: string
        if (!is_null($dateScheduled) && !is_string($dateScheduled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateScheduled, true), gettype($dateScheduled)), __LINE__);
        }
        $this->dateScheduled = $dateScheduled;
        return $this;
    }
    /**
     * Get inspector value
     * @return \StructType\User|null
     */
    public function getInspector()
    {
        return $this->inspector;
    }
    /**
     * Set inspector value
     * @param \StructType\User $inspector
     * @return \StructType\Inspection
     */
    public function setInspector(\StructType\User $inspector = null)
    {
        $this->inspector = $inspector;
        return $this;
    }
    /**
     * Get lease value
     * @return \StructType\Lease|null
     */
    public function getLease()
    {
        return $this->lease;
    }
    /**
     * Set lease value
     * @param \StructType\Lease $lease
     * @return \StructType\Inspection
     */
    public function setLease(\StructType\Lease $lease = null)
    {
        $this->lease = $lease;
        return $this;
    }
    /**
     * Get number value
     * @return int|null
     */
    public function getNumber()
    {
        return $this->number;
    }
    /**
     * Set number value
     * @param int $number
     * @return \StructType\Inspection
     */
    public function setNumber($number = null)
    {
        // validation for constraint: int
        if (!is_null($number) && !(is_int($number) || ctype_digit($number))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($number, true), gettype($number)), __LINE__);
        }
        $this->number = $number;
        return $this;
    }
    /**
     * Get portfolio value
     * @return \StructType\Portfolio|null
     */
    public function getPortfolio()
    {
        return $this->portfolio;
    }
    /**
     * Set portfolio value
     * @param \StructType\Portfolio $portfolio
     * @return \StructType\Inspection
     */
    public function setPortfolio(\StructType\Portfolio $portfolio = null)
    {
        $this->portfolio = $portfolio;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\Inspection
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get templateName value
     * @return string|null
     */
    public function getTemplateName()
    {
        return $this->templateName;
    }
    /**
     * Set templateName value
     * @param string $templateName
     * @return \StructType\Inspection
     */
    public function setTemplateName($templateName = null)
    {
        // validation for constraint: string
        if (!is_null($templateName) && !is_string($templateName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($templateName, true), gettype($templateName)), __LINE__);
        }
        $this->templateName = $templateName;
        return $this;
    }
    /**
     * Get timeInspected value
     * @return string|null
     */
    public function getTimeInspected()
    {
        return $this->timeInspected;
    }
    /**
     * Set timeInspected value
     * @param string $timeInspected
     * @return \StructType\Inspection
     */
    public function setTimeInspected($timeInspected = null)
    {
        // validation for constraint: string
        if (!is_null($timeInspected) && !is_string($timeInspected)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($timeInspected, true), gettype($timeInspected)), __LINE__);
        }
        $this->timeInspected = $timeInspected;
        return $this;
    }
    /**
     * Get timeScheduled value
     * @return string|null
     */
    public function getTimeScheduled()
    {
        return $this->timeScheduled;
    }
    /**
     * Set timeScheduled value
     * @param string $timeScheduled
     * @return \StructType\Inspection
     */
    public function setTimeScheduled($timeScheduled = null)
    {
        // validation for constraint: string
        if (!is_null($timeScheduled) && !is_string($timeScheduled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($timeScheduled, true), gettype($timeScheduled)), __LINE__);
        }
        $this->timeScheduled = $timeScheduled;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\Inspection
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get unit value
     * @return \StructType\Unit|null
     */
    public function getUnit()
    {
        return $this->unit;
    }
    /**
     * Set unit value
     * @param \StructType\Unit $unit
     * @return \StructType\Inspection
     */
    public function setUnit(\StructType\Unit $unit = null)
    {
        $this->unit = $unit;
        return $this;
    }
}
