<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReadOnlyVendorLedgerBillSplit StructType
 * @subpackage Structs
 */
class ReadOnlyVendorLedgerBillSplit extends ReadOnlyVendorLedgerItem
{
    /**
     * The buildingID
     * @var int
     */
    public $buildingID;
    /**
     * The portfolioID
     * @var int
     */
    public $portfolioID;
    /**
     * The unitID
     * @var int
     */
    public $unitID;
    /**
     * Constructor method for ReadOnlyVendorLedgerBillSplit
     * @uses ReadOnlyVendorLedgerBillSplit::setBuildingID()
     * @uses ReadOnlyVendorLedgerBillSplit::setPortfolioID()
     * @uses ReadOnlyVendorLedgerBillSplit::setUnitID()
     * @param int $buildingID
     * @param int $portfolioID
     * @param int $unitID
     */
    public function __construct($buildingID = null, $portfolioID = null, $unitID = null)
    {
        $this
            ->setBuildingID($buildingID)
            ->setPortfolioID($portfolioID)
            ->setUnitID($unitID);
    }
    /**
     * Get buildingID value
     * @return int|null
     */
    public function getBuildingID()
    {
        return $this->buildingID;
    }
    /**
     * Set buildingID value
     * @param int $buildingID
     * @return \StructType\ReadOnlyVendorLedgerBillSplit
     */
    public function setBuildingID($buildingID = null)
    {
        // validation for constraint: int
        if (!is_null($buildingID) && !(is_int($buildingID) || ctype_digit($buildingID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($buildingID, true), gettype($buildingID)), __LINE__);
        }
        $this->buildingID = $buildingID;
        return $this;
    }
    /**
     * Get portfolioID value
     * @return int|null
     */
    public function getPortfolioID()
    {
        return $this->portfolioID;
    }
    /**
     * Set portfolioID value
     * @param int $portfolioID
     * @return \StructType\ReadOnlyVendorLedgerBillSplit
     */
    public function setPortfolioID($portfolioID = null)
    {
        // validation for constraint: int
        if (!is_null($portfolioID) && !(is_int($portfolioID) || ctype_digit($portfolioID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($portfolioID, true), gettype($portfolioID)), __LINE__);
        }
        $this->portfolioID = $portfolioID;
        return $this;
    }
    /**
     * Get unitID value
     * @return int|null
     */
    public function getUnitID()
    {
        return $this->unitID;
    }
    /**
     * Set unitID value
     * @param int $unitID
     * @return \StructType\ReadOnlyVendorLedgerBillSplit
     */
    public function setUnitID($unitID = null)
    {
        // validation for constraint: int
        if (!is_null($unitID) && !(is_int($unitID) || ctype_digit($unitID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($unitID, true), gettype($unitID)), __LINE__);
        }
        $this->unitID = $unitID;
        return $this;
    }
}
